REM version 0.71 by Wojtek Wasilewski (wwasilewski@lucent.com) 25.08.1996

prgnam$="TMX2TAP"
usage$="Usage : "+prgnam$+" filename.ext | "+prgnam$+" -h"
crcsum=0

ON ERROR GOTO errhandl:

REM Remove extra spaces from command line parameter

FOR j=1 TO LEN(command$)
    temp$=MID$(command$,j,1)
    IF temp$<>" " THEN
    infile$=infile$+temp$
    END IF
NEXT j

IF command$="" THEN
   PRINT : PRINT : PRINT usage$ : PRINT
   END
ELSEIF command$="-h" OR command$="/h" THEN
   GOTO printdescr
END IF

infile$=UCASE$(infile$)

REM Check, if this is plain filename (no wildcards and/or pathname)

IF INSTR(infile$,"\") OR INSTR(infile$,"*") OR INSTR(infile$,"?") THEN
PRINT:PRINT "Wildcards and pathnames are not supported."
END
END IF

REM Check if input file exist. Non-existent file will cause error 53

OPEN infile$ FOR INPUT AS #1 : CLOSE #1

REM Only BASIC and CODE type TIMEX TOS files are supported.
REM The first byte of file must be 0 or 3.

OPEN infile$ FOR BINARY AS #1 : GET$ #1,1,temp$ : CLOSE #1

IF temp$<>CHR$(0) AND temp$<>CHR$(3) THEN
 PRINT:PRINT infile$;": Not valid TIMEX TOS file."
 CLOSE #1
 END
END IF

namelen=LEN(infile$): dotpos=INSTR(infile$,".")

IF dotpos=0 THEN
dotpos=namelen+1 : ext$=""
ELSE
ext$=RIGHT$(infile$,namelen-dotpos)
END IF

filename$=LEFT$(infile$,dotpos-1)

tapname$=filename$+".TAP": zxname$=infile$

IF namelen > 10 THEN
zxname$=LEFT$(filename$,4)+RIGHT$(filename$,2)+"."+ext$
END IF

zxname$=zxname$+SPACE$(10-LEN(zxname$))

PRINT:PRINT
PRINT "Emulator TAP file name :[";tapname$;"] ";:LINE INPUT temp$

IF temp$<>"" THEN
tapname$=UCASE$(temp$)
END IF

PRINT "ZX Spectrum file name  :[";zxname$;"] ";:LINE INPUT temp$

IF temp$<>"" THEN
zxname$=temp$
END IF

zxname$=zxname$+SPACE$(10-LEN(zxname$))

OPEN infile$ FOR BINARY AS #1
GET$ #1,1,type$ : GET$ #1,2,parm1$ : GET$ #1,2,parm2$

IF type$=CHR$(0) THEN
GET$ #1,2,parm3$
ELSE
parm3$=CHR$(0)+CHR$(128)
END IF

IF type$=CHR$(0) THEN
 zxstart$=parm1$ : zxlen$=parm2$ : bltyp$="LINE"
ELSE
 zxstart$=parm2$ : zxlen$=parm1$ : bltyp$="CODE"
END IF

REM Bulid 17-bytes header prepended by flagbyte

taphdr$=CHR$(0)+type$+zxname$+zxlen$+zxstart$+parm3$

REM Calculate checksum (actually checkbittoggle)

FOR j=1 TO LEN(taphdr$)
 temp$=MID$(taphdr$,j,1) : byteval=ASC(temp$)
 crcsum=crcsum XOR byteval
NEXT j

REM Prepend 2-bytes block length info (flagbyte+header+checksum = 19 bytes)

taphdr$=CHR$(19)+CHR$(0)+taphdr$+CHR$(crcsum)

temp$=MID$(zxstart$,1,1) : zxstartlo=ASC(temp$)
temp$=MID$(zxstart$,2,1) : zxstarthi=ASC(temp$)
zxstart=zxstartlo+256*zxstarthi

temp$=MID$(zxlen$,1,1) : zxlenlo=ASC(temp$)
temp$=MID$(zxlen$,2,1) : zxlenhi=ASC(temp$)
zxlen=zxlenlo+256*zxlenhi

REM Check if the output TAP file exists. If so, new data will be appended.

OPEN tapname$ FOR BINARY AS #2 : GET$ #2,1,temp$

IF LEN(temp$) <> 0 THEN
PRINT:PRINT "File ";tapname$;" already exists -- appending new data."
DO UNTIL EOF(2)
   GET$ #2,1024,temp$
LOOP
END IF

PRINT
PRINT "Converting : ";infile$;" ";bltyp$;STR$(zxstart);",";STR$(zxlen)
PRINT
PRINT "0         1         2         3         4        "
PRINT "H123456789012345678901234567890123456789012345678"

PUT$ #2,taphdr$ : PRINT "";

datlen=zxlen+2 : datlenhi=FIX(datlen/256)
datlenlo=datlen-256*datlenhi : crcsum=0

IF zxlen < 24577 THEN
GET$ #1,zxlen,buff$ : buff$=CHR$(255)+buff$

FOR j=1 TO LEN(buff$)
 temp$=MID$(buff$,j,1) : byteval=ASC(temp$)
 crcsum=crcsum XOR byteval
NEXT j

PUT$ #2,CHR$(datlenlo) : PUT$ #2,CHR$(datlenhi)
PUT$ #2,buff$ : PUT$ #2,CHR$(crcsum)
PRINT STRING$(zxlen/1024,"")

REM Data block is longer, than 24576 bytes. Convert in two steps.

ELSE

GET$ #1,24576,buff$ : buff$=CHR$(255)+buff$

FOR j=1 TO LEN(buff$)
 temp$=MID$(buff$,j,1) : byteval=ASC(temp$)
 crcsum=crcsum XOR byteval
NEXT j

PUT$ #2,CHR$(datlenlo) : PUT$ #2,CHR$(datlenhi) : PUT$ #2,buff$
PRINT STRING$(24,"");

buff$=""

GET$ #1,zxlen-24576,buff$

FOR j=1 TO LEN(buff$)
 temp$=MID$(buff$,j,1) : byteval=ASC(temp$)
 crcsum=crcsum XOR byteval
NEXT j

buff$=buff$+CHR$(crcsum) : PUT$ #2,buff$
PRINT STRING$((zxlen-24576)/1024,"")

END IF

CLOSE #1 : CLOSE #2

END

errhandl:

IF ERR=53 THEN
 PRINT:PRINT "E53 File not found."
ELSEIF ERR=75 THEN
 PRINT:PRINT "E75 Path/file access error."
ELSEIF ERR=14 THEN
 PRINT:PRINT "E14 Out of string space."
ELSE
 PRINT:PRINT "Error Nr:";ERR

END IF : END

printdescr:

PRINT:PRINT
? prgnam$;" ver 0.71 by Wojtek Wasilewski (wwasilewski@lucent.com) 25.08.1996"
?
? "The purpose of this program is conversion of files in TIMEX TOS format to"
? "the TAP file format acceptable by most ZX Spectrum emulators. TOS files"
? "can be transferred directly from 5 1/4 floppy disks using excellent Sydex"
? "utility 22DISK. During conversion program suggests names for output TAP"
? "file and internal Spectrum name. The names are derived from TOS file name"
? "and in most cases are sufficient, but can be changed if necessary. If the"
? "output TAP file already exists, new data is appended."
?:? usage$
END